<?php

namespace FiloBlu\Flow\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Console\Input\InputArgument;
use Magento\Framework\Module\ModuleListInterface;


class FetchCommand extends Command
{

    private $cronModel;
    const BUS_ARGUMENT = 'bus';

    public function __construct(\FiloBlu\Flow\Cron\Fetch $cronModel)
    {
        $this->cronModel = $cronModel;
        parent::__construct();
    }

    protected function configure()
    {
        $this->setName('flow:fetch')
            ->setDescription('Retrieve files/data from remote source')
            ->setDefinition([
                new InputArgument(
                    self::BUS_ARGUMENT,
                    InputArgument::OPTIONAL,
                    'Bus'
                ),
            ]);
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $bus = (int) $input->getArgument(self::BUS_ARGUMENT);

        $bus = (!$bus) ? 1 : $bus;

        if (($bus < 1 || $bus > 4) && $bus) {
            throw new \InvalidArgumentException('Argument ' . self::BUS_ARGUMENT . ' is wrong.');
        }

        switch ($bus) {

            case 1:
                $this->cronModel->executeBus1();
                break;
            case 2:
                $this->cronModel->executeBus2();
                break;
            case 3:
                $this->cronModel->executeBus3();
                break;
            case 4:
                $this->cronModel->executeBus4();
                break;

        }

        $output->writeln('<info>Fetch executed on bus ' . $bus . '!</info>');
    }

}